<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: return PHP constants
 *
 */

// function return result array
function getPHPINFO_INFO_ALL()
{
	return getPHPINFO( INFO_ALL );
}
function getPHPINFO_INFO_GENERAL()
{
	return getPHPINFO( INFO_GENERAL );
}
function getPHPINFO_INFO_CREDITS()
{
	return getPHPINFO( INFO_CREDITS );
}
function getPHPINFO_INFO_CONFIGURATION()
{
	return getPHPINFO( INFO_CONFIGURATION );
}
function getPHPINFO_INFO_MODULES()
{
	return getPHPINFO( INFO_MODULES );
}
function getPHPINFO_INFO_ENVIRONMENT()
{
	return getPHPINFO( INFO_ENVIRONMENT );
}
function getPHPINFO_INFO_VARIABLES()
{
	return getPHPINFO( INFO_VARIABLES );
}
function getPHPINFO_INFO_LICENSE()
{
	return getPHPINFO( INFO_LICENSE );
}

function getPHPINFO( $select)
{
	// define the array
	$envinfoArray = Array();
	
	// source:  comment from "Ken" at http://php.net/manual/en/function.phpinfo.php
	ob_start();
	phpinfo( $select );
	$info_lines = explode("\n", strip_tags(ob_get_clean(), "<tr><td><h2>"));
	$cat = "General";
	foreach( $info_lines as $line ):
		// new cat?
		preg_match("~<h2>(.*)</h2>~", $line, $title) ? $cat = $title[1] : null;
		if ( preg_match("~<tr><td[^>]+>([^<]*)</td><td[^>]+>([^<]*)</td></tr>~", $line, $val) ):
			$envinfoArray[$cat][$val[1]] = $val[2];
		elseif ( preg_match("~<tr><td[^>]+>([^<]*)</td><td[^>]+>([^<]*)</td><td[^>]+>([^<]*)</td></tr>~", $line, $val) ):
			$envinfoArray[$cat][$val[1]] = array("local" => $val[2], "master" => $val[3]);
		endif;
	endforeach;

	// return the array
	return $envinfoArray;
}

// return the select option
	$infoItems["getPHPINFO_INFO_ALL"] 			= "INFO_ALL";
	$infoItems["getPHPINFO_INFO_GENERAL"] 		= "INFO_GENERAL";
	$infoItems["getPHPINFO_INFO_CREDITS"] 		= "INFO_CREDITS";
	$infoItems["getPHPINFO_INFO_CONFIGURATION"] = "INFO_CONFIGURATION";
	$infoItems["getPHPINFO_INFO_MODULES"] 		= "INFO_MODULES";
	$infoItems["getPHPINFO_INFO_ENVIRONMENT"] 	= "INFO_ENVIRONMENT";
	$infoItems["getPHPINFO_INFO_VARIABLES"] 	= "INFO_VARIABLES";
	$infoItems["getPHPINFO_INFO_LICENSE"] 		= "INFO_LICENSE";

// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['INFO_ALL'] 			= "PHPINFO: INFO_ALL - Zeigt komplettes PHPINFO an.";
			$ENVINFOTEXT['INFO_GENERAL'] 		= "PHPINFO: INFO_GENERAL - Die Konfigurationszeile, die Ort der php.ini, das bersetzungsdatum, der Webserver, das System und mehr.";
			$ENVINFOTEXT['INFO_CREDITS'] 		= "PHPINFO: INFO_CREDITS - PHP-Credits. ";
			$ENVINFOTEXT['INFO_CONFIGURATION'] 	= "PHPINFO: INFO_CONFIGURATION - Aktueller lokaler und Master-Wert der PHP-Direktiven. ";
			$ENVINFOTEXT['INFO_MODULES'] 		= "PHPINFO: INFO_MODULES - Die geladenene Module und ihre jeweiligen Einstellungen.";
			$ENVINFOTEXT['INFO_ENVIRONMENT'] 	= "PHPINFO: INFO_ENVIRONMENT - Informationen ber die Umgebungsvariablen.";
			$ENVINFOTEXT['INFO_VARIABLES'] 		= "PHPINFO: INFO_VARIABLES - Zeigt alle vordefinierten Variablen aus EGPCS (Environment, GET, POST, Cookie, Server). ";
			$ENVINFOTEXT['INFO_LICENSE'] 		= "PHPINFO: INFO_LICENSE - PHP-Lizenz-Informationen.";
			break;
	default:
			$ENVINFOTEXT['INFO_ALL'] 			= "PHPINFO: INFO_ALL - Shows all of PHPINFO";
			$ENVINFOTEXT['INFO_GENERAL'] 		= "PHPINFO: INFO_GENERAL - The configuration line, php.ini location, build date, Web Server, System and more.";
			$ENVINFOTEXT['INFO_CREDITS'] 		= "PHPINFO: INFO_CREDITS - PHP Credits.";
			$ENVINFOTEXT['INFO_CONFIGURATION'] 	= "PHPINFO: INFO_CONFIGURATION - Current Local and Master values for PHP directives.";
			$ENVINFOTEXT['INFO_MODULES'] 		= "PHPINFO: INFO_MODULES - Loaded modules and their respective settings.";
			$ENVINFOTEXT['INFO_ENVIRONMENT'] 	= "PHPINFO: INFO_ENVIRONMENT - Environment Variable information.";
			$ENVINFOTEXT['INFO_VARIABLES'] 		= "PHPINFO: INFO_VARIABLES - Shows all predefined variables from EGPCS (Environment, GET, POST, Cookie, Server).";
			$ENVINFOTEXT['INFO_LICENSE'] 		= "PHPINFO: INFO_LICENSE - PHP License information";
	
	endswitch;

?>
