<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: return section_picker assignemnts
 *
 */

// function return result array
function getSECTION_PICKER()
{
	global $database;
	global $ENVINFOTEXT;
	
	// define the array
	$envinfoArray = Array();
	
	// check if section_picker module is installed
	$directory = WB_PATH . '/modules/section_picker';
	if (( is_dir($directory) == FALSE ) || ( file_exists($directory . "/info.php") == FALSE )):
		return $envinfoArray;
	endif;
	
	// get assignments
	$table_section_picker = TABLE_PREFIX . "mod_section_pick";
	$table_section        = TABLE_PREFIX . "sections";
	$table_page           = TABLE_PREFIX . "pages";

	// check if section name is available (Lepton yes, Websitebaker maybe ?, others ... ???)
	$useSectionName = FALSE;
	$query = "SELECT * FROM " . $table_section . " LIMIT 1";
	if ( $query_data = $database->query( $query) ):
		$result = $query_data->fetchRow();
		
		if ( in_array( "name", $result ) == TRUE ):
			$useSectionName = TRUE;
		endif;
	endif;
	
	// now get real data
	$query = "SELECT sp.section_id, sp.page_id, sp.target_section_id, ts.page_id AS target_page_id
					, p.page_title, p.visibility
					" . ( $useSectionName == TRUE ? ", s.name" : "" ) . "
					, s.module, s.block, s.publ_start, s.publ_end
					, tp.page_title AS target_page_title, tp.visibility AS target_visibility
					" . ( $useSectionName == TRUE ? ", ts.name AS target_name" : "" ) . "
					, ts.module AS target_module, ts.block AS target_block, ts.publ_start AS target_publ_start, ts.publ_end AS target_publ_end
			FROM " . $table_section_picker . " sp
			JOIN " . $table_section . " s  ON sp.section_id = s.section_id
			JOIN " . $table_page .    " p  ON sp.page_id = p.page_id
			JOIN " . $table_section . " ts ON sp.target_section_id = ts.section_id
			JOIN " . $table_page .    " tp ON ts.page_id = tp.page_id
			ORDER BY p.page_title, sp.page_id, sp.section_id ASC";
		
	if ( $query_data = $database->query( $query) ):
		while ( $result = $query_data->fetchRow() ):
		
			$pageKey = "P" .  $result['page_id'] . " - " .  $result['page_title'];
			$sectionKey = "S" .  $result['section_id'] . " - " .  $result['name'];
			$groupKey = $ENVINFOTEXT['SECTION_PICKER_CURRENT'];

			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page id']			=  $result['page_id'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page title']			=  $result['page_title'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility']	=  $result['visibility'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section id']			=  $result['section_id'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section_name']		=  ( in_array( "name", $result ) == TRUE ? $result['name'] : "-- n.a. --" );
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section module']		=  $result['module'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section block']		=  $result['block'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start']		= ( $result['publ_start'] > 0 ? date('d/m/Y', $result['publ_start']) : '');
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end']		= ( $result['publ_end'] > 0 ? date('d/m/Y', $result['publ_end']) : '');

			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility'];
			if ( $testVal == "deleted" ):	// current page is deleted
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility'] = '<span class="info">' . $testVal . '</span>';
			endif;
			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start'];
			if (( empty( $testVal ) == FALSE ) && ( $testVal > time() )):		// current section is not yet valid
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start'] = '<span class="info">' . $testVal . '</span>';
			endif;
			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end'];
			if (( empty( $testVal ) == FALSE ) && ( $testVal < time() )):		// current section is no longer valid
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end'] = '<span class="info">' . $testVal . '</span>';
			endif;
			

			$groupKey = $ENVINFOTEXT['SECTION_PICKER_LINK'];

			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page id']			=  $result['target_page_id'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page title']			=  $result['target_page_title'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility']	=  $result['target_visibility'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section id']			=  $result['target_section_id'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section_name']		=  ( in_array( "target_name", $result ) == TRUE ? $result['target_name'] : "-- n.a. --" );
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section module']		=  $result['target_module'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section block']		=  $result['target_block'];
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start']		= ( $result['target_publ_start'] > 0 ? date('d/m/Y',  $result['target_publ_start']) : '');
			$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end']		= ( $result['target_publ_end'] > 0 ? date('d/m/Y', $result['target_publ_end']) : '');

			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility'];
			if ( $testVal == "deleted" ):	// link page is deleted
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['page visibility'] = '<span class="warning">' . $testVal . '</span>';
			endif;
			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start'];
			if (( empty( $testVal ) == FALSE ) && ( $testVal > time() )):		// link section is not yet valid
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section start'] = '<span class="info">' . $testVal . '</span>';
			endif;
			$testVal = $envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end'];
			if (( empty( $testVal ) == FALSE ) && ( $testVal < time() )):		// link section is no longer valid
				$envinfoArray[ $pageKey ][ $sectionKey ][ $groupKey ]['section end'] = '<span class="warning">' . $testVal . '</span>';
			endif;
			
		endwhile;
	endif;

	// return the array
	return $envinfoArray;
}

// return the select option
	// Add item only if module is installed
	$directory = WB_PATH . '/modules/section_picker';
	if (( is_dir($directory) == TRUE ) || ( file_exists($directory . "/info.php") == TRUE )):
		$infoItems["getSECTION_PICKER"] = "SECTION_PICKER";
	endif;
	
// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['SECTION_PICKER'] 			= "Section_picker - zeigt vorhandene Verknpfungen.";
			$ENVINFOTEXT['SECTION_PICKER_CURRENT']	= "Auf Seite";
			$ENVINFOTEXT['SECTION_PICKER_LINK']		= "Link nach";
			break;
	default:
			$ENVINFOTEXT['SECTION_PICKER'] 			= "Section_picker - show available assignments.";
			$ENVINFOTEXT['SECTION_PICKER_CURRENT']	= "On Page";
			$ENVINFOTEXT['SECTION_PICKER_LINK']		= "Link to";
	
	endswitch;

?>
