<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: prepare output table tree
 *
 */

// function return result array
function outTABLE_TREE()
{
	global $envinfoArray;
	
	// get total level depth
	$array_depth = 0;
	array_depth( $envinfoArray, 1, $array_depth );
	$array_depth += 1;	// for last none-array element

	
	// create table header
	echo '<table class="envinfo_table" >' . PHP_EOL;
	
	// calculate first average width
		// define total width
	$totWidth = 870;
		// last column weight is factor 2.5
		// second last column weight is factor 2
		// all other columns weight is factor 0.75
		// due to, weight factor is ( total number of columns (=$array_depth) * 0.75) + 1 (for second last column) + 1.5 (for last column)
	$avgWidth = round( ($totWidth / (($array_depth * 0.75) + 1 + 1.5 )), 0);
	
	// create table column width
	echo '<colgroup>' . PHP_EOL;
	for ($i=1; $i<$array_depth-1;$i++):
		echo '	<col width="' . $avgWidth . '">' . PHP_EOL;
		$totWidth -= $avgWidth;
	endfor;
	echo '	<col width="' . ( $avgWidth * 2 ) . '">' . PHP_EOL;	// key column
		$totWidth -= ( $avgWidth * 2 );
	echo '	<col width="' . $totWidth . '">' . PHP_EOL;	// value column gets rest
	echo '</colgroup>' . PHP_EOL;
	 
	// fill table with details
	outTABLE_TREE_detail( $envinfoArray, 1, $array_depth );
	
	// close tables
	echo '</table>' . PHP_EOL;

	// return
	return TRUE;
}

/**
 * following functions have been found at http://terrawebdesign.com/multidimensional.php
 * and has been manipulated and enhanced by myself to cover my needs
 */
 
// function to add number of empty cells in front of current cell
function outTABLE_TREE_offset( $level ) 
{
	$offset = "";             // offset for sub-array 
	for ($i=1; $i<$level;$i++):
		$offset = $offset . '<td class="envinfo_td_offset" >&nbsp;</td>';
	endfor;
	return $offset;
}

// function to build data cells
function outTABLE_TREE_detail( $array, $level, $array_depth ) {
	
	global $ENVINFOTEXT;
	
	if ( is_array($array) == TRUE ):			// check if input is an array
		foreach( $array as $key_val => $value ):
			$offset = "";
			if (is_array($value) == TRUE ):		// array is multidimensional
				echo '<tr class="envinfo_tr level' . $level . '" >';
				$offset = outTABLE_TREE_offset($level);
				$anchor = '<a class="envinfo_anchor" id="L' . $level . '-' . $key_val . '"></a>';
				$colspan = $array_depth - $level + 1;
				echo $offset . '<td colspan="' . $colspan . '" class="envinfo_td_main level' . $level . '" >' . $anchor . '<a class="envinfo_anchor_TOP" title="' . $ENVINFOTEXT['GOTO_TOP'] . '"href="#TOP">' . $key_val . '</a></td></tr>' . PHP_EOL;
				outTABLE_TREE_detail( $value, $level+1, $array_depth );

			else:								// (sub)array is not multidim
				echo "<tr envinfo_tr_nosub>";
				$offset = outTABLE_TREE_offset($level);
				$colspan = $array_depth - $level + 2;
				echo $offset . '<td class="envinfo_td_key">' . $key_val . '</td><td colspan="' . $colspan . '" class="envinfo_td_value">' . $value . '</td></tr>' . PHP_EOL;
			endif;
       endforeach;
    else: // argument $array is not an array
        return;
    endif;
}



// return the select option
	$outItems["outTABLE_TREE"] = "TABLE_TREE";

// build GOTO list
	$gotoPrepare["outTABLE_TREE"] = TRUE;

// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['TABLE_TREE'] = "TABLE TREE - Tabellenbasierte Baumstruktur (Standard)";
			break;
	default:
			$ENVINFOTEXT['TABLE_TREE'] = "TABLE TREE - Table based Tree (Default).";
	
	endswitch;

?>
